<HTML>
<HEAD>
<TITLE>HEPiX X11 Scripts - Variables</TITLE>
<!-- Changed by: Lionel Cons,  1-Oct-1997 -->
</HEAD>
<BODY>

<H1>HEPiX X11 Scripts - Variables</H1>

<P> This page describes the different variables used by the <A HREF=".">HEPiX X11 scripts</A>. They
can be roughly classified into <A HREF="#switches">major switches</A>,
<A HREF="#info">informational variables</A> and
<A HREF="#misc">miscellaneous variables</A>.

<P> Index: <A HREF="#DOT_XSESSION">DOT_XSESSION</A> - <A HREF="#GROUP_DIR">GROUP_DIR</A> - <A HREF="#HX_COLOR">HX_COLOR</A> - <A HREF="#HX_DESKTOP">HX_DESKTOP</A> - <A HREF="#HX_EXTENSIONS">HX_EXTENSIONS</A> - <A HREF="#HX_FONT_PATH">HX_FONT_PATH</A> - <A HREF="#HX_GROUP_DIR">HX_GROUP_DIR</A> - <A HREF="#HX_HEIGHT">HX_HEIGHT</A> - <A HREF="#HX_KBD_MISC">HX_KBD_MISC</A> - <A HREF="#HX_KEYBOARD">HX_KEYBOARD</A> - <A HREF="#HX_LAST_CLIENT">HX_LAST_CLIENT</A> - <A HREF="#HX_PLANES">HX_PLANES</A> - <A HREF="#HX_RELEASE">HX_RELEASE</A> - <A HREF="#HX_RESOLUTION">HX_RESOLUTION</A> - <A HREF="#HX_RESPONSE">HX_RESPONSE</A> - <A HREF="#HX_ROOT_WINDOW">HX_ROOT_WINDOW</A> - <A HREF="#HX_SERVER_HOST">HX_SERVER_HOST</A> - <A HREF="#HX_SERVER_TYPE">HX_SERVER_TYPE</A> - <A HREF="#HX_SIZE">HX_SIZE</A> - <A HREF="#HX_SOURCEPROFILE">HX_SOURCEPROFILE</A> - <A HREF="#HX_START_MXCONNS">HX_START_MXCONNS</A> - <A HREF="#HX_STARTUP">HX_STARTUP</A> - <A HREF="#HX_VENDOR">HX_VENDOR</A> - <A HREF="#HX_VENDOR_STRING">HX_VENDOR_STRING</A> - <A HREF="#HX_VERSION">HX_VERSION</A> - <A HREF="#HX_WIDTH">HX_WIDTH</A> - <A HREF="#HX_WM">HX_WM</A> - <A HREF="#XDISPLAY">XDISPLAY</A>

<P> <HR> <P>

<A NAME="switches"><H1>Major Switches</H1></A>

<P> Here are the major switches (i.e. variables influencing the HEPiX
X11 scripts behaviour) that can be set in the <A HREF="./files.html#xprofile"><CODE>xprofile</CODE></A> files. They
are used only by the HEPiX desktop (except <A HREF="./vars.html#HX_START_MXCONNS"><CODE>$HX_START_MXCONNS</CODE></A> and
<A HREF="./vars.html#HX_DESKTOP"><CODE>$HX_DESKTOP</CODE></A> of course). Some of them are even only used by the HEPiX
startup: <A HREF="./vars.html#HX_FONT_PATH"><CODE>$HX_FONT_PATH</CODE></A>, <A HREF="./vars.html#HX_LAST_CLIENT"><CODE>$HX_LAST_CLIENT</CODE></A>, <A HREF="./vars.html#HX_ROOT_WINDOW"><CODE>$HX_ROOT_WINDOW</CODE></A> and <A HREF="./vars.html#HX_WM"><CODE>$HX_WM</CODE></A>.

<P> Note that the default values for these variables depend on many
factors. For instance, if you work at CERN for the CHORUS experiment,
the default value of a given variable can come either from the HEP
level default, or from the CERN customisation, or from the CHORUS
customisation or even from the machine level customisation! The best
thing to do is to use an empty <A HREF="./files.html#xprofile"><CODE>xprofile</CODE></A>, start an X session and look
in <A HREF="./files.html#$HOME/.hepix/xsession.log"><CODE>$HOME/.hepix/xsession.log</CODE></A> ...

<A NAME="HX_DESKTOP"><H3><CODE>HX_DESKTOP</CODE></H3></A>

<P> The name of the desktop to use. The HEPiX X session will execute
the program <CODE>HEP_desktop.$HX_DESKTOP</CODE> that must exists at
hep level. This does not apply to the HEPiX desktop that is coded
inside the HEPiX X session.

<P> The main desktops recognised are (availability depends on the
machine of course):
<UL>
<LI> <CODE>CDE</CODE>:       COSE Common Desktop Environment
<LI> <CODE>DXSESSION</CODE>: Digital <CODE>dxsession</CODE>
<LI> <CODE>HEPIX</CODE>:     the HEPiX desktop (default)
<LI> <CODE>HP-VUE</CODE>:    HP Visual User Environment
<LI> <CODE>OPENLOOK</CODE>:  Sun Openlook
</UL>

<A NAME="HX_FONT_PATH"><H3><CODE>HX_FONT_PATH</CODE></H3></A>

<P> The font path to append with the command
`<A HREF="./tools.html#xsetfp"><CODE>xsetfp</CODE></A> $HX_FONT_PATH'.

<A NAME="HX_LAST_CLIENT"><H3><CODE>HX_LAST_CLIENT</CODE></H3></A>

<P> The last client that is executed (a real <CODE>exec</CODE>) by the
HEPiX X session. It can be either a full command or
"<SAMP>local</SAMP>" (i.e. a small <CODE>xterm</CODE>) or
"<SAMP>window-manager</SAMP>" (i.e. we use the value of <A HREF="./vars.html#HX_WM"><CODE>$HX_WM</CODE></A>).

<A NAME="HX_ROOT_WINDOW"><H3><CODE>HX_ROOT_WINDOW</CODE></H3></A>

<P> The command to run when the X session is started to set the root
window color and/or pattern. You can use for instance "<SAMP>xsetroot
-solid seagreen</SAMP>" (set color to green). See the man page of
<CODE>xsetroot</CODE> for more information.

<A NAME="HX_SOURCEPROFILE"><H3><CODE>HX_SOURCEPROFILE</CODE></H3></A>

<P> Whether or not to source the user's shell "profile"
(<CODE>.login</CODE>, <CODE>.profile</CODE>...) to get his private
environment variables settings (like <CODE>$PRINTER</CODE>). Can be
"<SAMP>yes</SAMP>" or "<SAMP>no</SAMP>".

<P> Although the program used to get these environment variables
(<A HREF="./tools.html#dump_shell_env"><CODE>dump_shell_env</CODE></A>) is quite strong, users should be careful not to put
in their files things that could block the X session...

<A NAME="HX_START_MXCONNS"><H3><CODE>HX_START_MXCONNS</CODE></H3></A>

<P> Whether or not to start the program <CODE>mxconns</CODE> and set
the variable <A HREF="./vars.html#XDISPLAY"><CODE>$XDISPLAY</CODE></A>. It can be either "<SAMP>yes</SAMP>" or
"<SAMP>no</SAMP>" or the full command line with the appropriate
options, for instance "<SAMP>mxconns -iconic -fork -verbose -hunt</SAMP>".

<P> <CODE>mxconns</CODE> will be started just after loading the X
resources, before handling <A HREF="./vars.html#HX_DESKTOP"><CODE>$HX_DESKTOP</CODE></A>. The recommended way to
customise <CODE>mxconns</CODE> is to set some X resources, for
instance:
<PRE>
	mxconns*iconic:         true
	mxconns*geometry:       +0-0
</PRE>

<P> <STRONG>Warning</STRONG>: the program must put itself in the
background (this is the purpose of the "-fork" flag of
<CODE>mxconns</CODE>) otherwise the X session will hang.

<A NAME="HX_STARTUP"><H3><CODE>HX_STARTUP</CODE></H3></A>

<P> The startup file to use. It can be either a full command or
"<SAMP>HEPiX</SAMP>" or "<SAMP>dot-xsession</SAMP>" (which is the same
as "<SAMP>$HOME/.xsession</SAMP>").

<P> <STRONG>Warning</STRONG>: if a <A HREF="./files.html#$HOME/.xsession"><CODE>$HOME/.xsession</CODE></A> file exists and is
executable then it is always used, regardless of the value of
<A HREF="./vars.html#HX_STARTUP"><CODE>$HX_STARTUP</CODE></A>.

<A NAME="HX_WM"><H3><CODE>HX_WM</CODE></H3></A>

<P> The window manager to use. It can be either a full command or
"<SAMP>local</SAMP>" (i.e. no window manager is started) or
"<SAMP>last-client</SAMP>" (i.e. no window manager is started, hoping
that the last client is the window manager...).

<P> It can also be of the form "<SAMP>local-foo args</SAMP>". In this case,
the tool <A HREF="./tools.html#local-client"><CODE>local-client</CODE></A> will be used to try to start a local client
named "<SAMP>foo</SAMP>".

<P> Finally, if the string "<SAMP>-prepare</SAMP>" appears, the tool
<A HREF="./tools.html#prepare-wmrc"><CODE>prepare-wmrc</CODE></A> will be used to prepare the window manager configuration file.
"<SAMP>foowm -prepare args</SAMP>" is equivalent to
"<SAMP>foowm `prepare-wmrc foowm` args</SAMP>". See also,
<A HREF="./files.html#$HOME/.hepix/wm/generated_wmrc"><CODE>$HOME/.hepix/wm/generated_wmrc</CODE></A>.

<P> <HR> <P>

<A NAME="info"><H1>Informational Variables</H1></A>

<P> They give some information on the X environment of the X
session. Most of them are set by the HEPiX X session and not meant to
be changed.

<P> They are all set by the program <A HREF="./tools.html#xinfo"><CODE>xinfo</CODE></A> except:
<UL>
<LI> <A HREF="./vars.html#HX_KEYBOARD"><CODE>$HX_KEYBOARD</CODE></A> that is not (yet) set at hep level
<LI> <A HREF="./vars.html#HX_VERSION"><CODE>$HX_VERSION</CODE></A> that is set directly by the X session
</UL>

<A NAME="HX_COLOR"><H3><CODE>HX_COLOR</CODE></H3></A>
<P> The color type of the screen:
`<SAMP>black</SAMP>'(?), `<SAMP>monochrom</SAMP>',
`<SAMP>greyscale</SAMP>' or `<SAMP>color</SAMP>'

<A NAME="HX_EXTENSIONS"><H3><CODE>HX_EXTENSIONS</CODE></H3></A>
<P> The list of extensions in a string separated by spaces,
e.g. `<SAMP>HPExtension XTestExtension1 SHAPE MIT-SHM</SAMP>'

<A NAME="HX_HEIGHT"><H3><CODE>HX_HEIGHT</CODE></H3></A>
<P> The height of the screen in pixels

<A NAME="HX_KBD_MISC"><H3><CODE>HX_KBD_MISC</CODE></H3></A>
<P> Misc information about the keyboard, usually depending on the X server vendor;
e.g. on NCDs we can find the model name: `<SAMP>N-101</SAMP>'

<A NAME="HX_KEYBOARD"><H3><CODE>HX_KEYBOARD</CODE></H3></A>
<P> The "official" name of the keyboard as known by the X program <CODE>xkeycaps</CODE>,
e.g. `<SAMP>LK201</SAMP>'

<A NAME="HX_PLANES"><H3><CODE>HX_PLANES</CODE></H3></A>
<P> The number of planes, usually 2, 8 or 16

<A NAME="HX_RELEASE"><H3><CODE>HX_RELEASE</CODE></H3></A>
<P> The vendor release number,
e.g. `<SAMP>507000</SAMP>'

<A NAME="HX_RESOLUTION"><H3><CODE>HX_RESOLUTION</CODE></H3></A>
<P> The average resolution in dpi, as known by the X server: (x_dpi + y_dpi) / 2

<A NAME="HX_RESPONSE"><H3><CODE>HX_RESPONSE</CODE></H3></A>
<P> An indication of the X connectivity speed:
the time spent to run the <A HREF="./tools.html#xinfo"><CODE>xinfo</CODE></A> program itself, in milliseconds

<A NAME="HX_SERVER_HOST"><H3><CODE>HX_SERVER_HOST</CODE></H3></A>
<P> The hostname of the X server, useful when the display is only <CODE>:0</CODE>

<A NAME="HX_SERVER_TYPE"><H3><CODE>HX_SERVER_TYPE</CODE></H3></A>
<P> The "type" of the X server, mainly derived from the vendor string:
workstation (<SAMP>ws</SAMP>), X terminal (<SAMP>xt</SAMP>),
Macintosh (<SAMP>mac</SAMP>) or PC-compatible (<SAMP>pc</SAMP>)

<A NAME="HX_SIZE"><H3><CODE>HX_SIZE</CODE></H3></A>
<P> The "simple" size of the screen:
`<SAMP>small</SAMP>', `<SAMP>medium</SAMP>' or `<SAMP>big</SAMP>';
the algorithm is (with pixels = width * height):
<UL>
<LI> if (pixels &gt; 1000000) then <CODE>HX_SIZE</CODE>=<SAMP>big</SAMP>
<LI> if (pixels &gt;  400000) then <CODE>HX_SIZE</CODE>=<SAMP>medium</SAMP>
<LI> otherwise <CODE>HX_SIZE</CODE>=<SAMP>small</SAMP>
</UL>

<A NAME="HX_VENDOR"><H3><CODE>HX_VENDOR</CODE></H3></A>
<P> The vendor derived from the vendor string with a table,
e.g. `<SAMP>hp</SAMP>'

<A NAME="HX_VENDOR_STRING"><H3><CODE>HX_VENDOR_STRING</CODE></H3></A>
<P> The exact vendor string,
e.g. `<SAMP>Hewlett-Packard Company</SAMP>'

<A NAME="HX_VERSION"><H3><CODE>HX_VERSION</CODE></H3></A>
<P> The version of the HEPiX X11 scripts used,
e.g. `<SAMP>3.1.2</SAMP>'

<A NAME="HX_WIDTH"><H3><CODE>HX_WIDTH</CODE></H3></A>
<P> The width of the screen in pixels

<P> <HR> <P>

<A NAME="misc"><H1>Miscellaneous Variables</H1></A>

<P> Many environment variables are set by the <A HREF="./../shells">HEPiX shells scripts</A>,
they are described <A HREF="../shells/vars.html">elsewhere</A>.

<A NAME="DOT_XSESSION"><H3><CODE>DOT_XSESSION</CODE></H3></A>

<P> Whether or not we are running the user's <A HREF="./files.html#$HOME/.xsession"><CODE>$HOME/.xsession</CODE></A> .
It is set by the HEPiX X session before executing the user's
<CODE>.xsession</CODE> to detect loops if the <CODE>.xsession</CODE>
calls the HEPiX X session (used when the <CODE>xdm</CODE> wrappers are
not installed).

<A NAME="GROUP_DIR"><H3><CODE>GROUP_DIR</CODE></H3></A>

<P> The old location of the group level customisations. Starting with
the version 3.2, it is now replaced by <A HREF="./vars.html#HX_GROUP_DIR"><CODE>$HX_GROUP_DIR</CODE></A>.

<A NAME="HX_GROUP_DIR"><H3><CODE>HX_GROUP_DIR</CODE></H3></A>

<P> The location of the group level customisations for the <A HREF=".">HEPiX X11 scripts</A>.
It is normally set in the site-level <A HREF="./files.html#xprofile"><CODE>xprofile</CODE></A> file.

<A NAME="XDISPLAY"><H3><CODE>XDISPLAY</CODE></H3></A>

<P> The pseudo display created by <CODE>mxconns</CODE>. This is the
value to use (instead of <CODE>$DISPLAY</CODE>) when you want the X
client to go through <CODE>mxconns</CODE>. Some tools like
<CODE>xrsh</CODE> (modified at CERN) use this variable.

<P> <HR> <P>

<ADDRESS>
<A HREF="http://wwwinfo.cern.ch/~cons">Lionel Cons</A>,  1-Oct-1997
</ADDRESS>

</BODY>
</HTML>
